﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace TechNote62_TextViewer_CS
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        // FileSearch를 사용해서 저장한 구조체 파일 리스트
        SmartX.SmartFile.SEARCHFILEINFOS[] m_sFoundFileList;
        private int m_iSelectMemory;

        private void Form1_Load(object sender, EventArgs e)
        {
            // 현재 Form을 MainForm으로 설정합니다.
            smartForm1.MainForm = this;
            // 자식 폼을 추가합니다.
            smartForm1.AddChildForm(smartInnerForm1);
            smartForm1.AddChildForm(smartInnerForm2);
            smartForm1.Show(0);

            smartGroupBox1.Visible = false;
        }

        private void btnFlashDisk_Click(object sender, EventArgs e)
        {
            m_iSelectMemory = 0;
            DeviceSelect(m_iSelectMemory);
        }

        private void btnHardDisk_Click(object sender, EventArgs e)
        {
            m_iSelectMemory = 1;
            DeviceSelect(m_iSelectMemory);
        }

        private void btnSDCard_Click(object sender, EventArgs e)
        {
            m_iSelectMemory = 2;
            DeviceSelect(m_iSelectMemory);
        }

        private void btnAll_Click(object sender, EventArgs e)
        {
            m_iSelectMemory = 3;
            DeviceSelect(m_iSelectMemory);
        }

        private void labSearch_Click(object sender, EventArgs e)
        {
            smartGroupBox1.Location = new Point(40, 5);

            smartGroupBox1.Visible = true;

            smartKeyboard1.Show();
            smartKeyboard1.TargetInputObject = labSearchWord;
        }

        private void btnCompletion_Click(object sender, EventArgs e)
        {
            labSearch.Text = labSearchWord.Text;
            smartGroupBox1.Visible = false;
        }

        private void btnSearch_Click(object sender, EventArgs e)
        {
            // 현재 경로의 파일 리스트를 얻습니다.
            DeviceSelect(m_iSelectMemory);
        }

        private void lstFileList_DoubleClick(object sender, EventArgs e)
        {
            FileSelect();   
        }

        private void btnScrollButton_Click(object sender, EventArgs e)
        {
            if (sender == btnScrollUp)
            {
                lstFileList.ScrollUp();
            }
            else
            {
                lstFileList.ScrollDown();
            }
        }

        private void btnBack_Click(object sender, EventArgs e)
        {
            lstFileList.ClearAll();
            smartForm1.Show(0);
        }

        private void btnClose_Click(object sender, EventArgs e)
        {
            smartForm1.Show(1);
        }

        private void btnSelect_Click(object sender, EventArgs e)
        {
            FileSelect();
        }

        private void DeviceSelect(int iSelectMemory)
        {
            string strSearchWord;

            smartForm1.Show(1);

            // 리스트 항목 모두 삭제
            lstFileList.ClearAll();

            if (labSearch.Text == "")
            {
                strSearchWord = "*.txt;*.dat;";
            }
            else
            {
                strSearchWord = labSearch.Text;
            }

            switch (iSelectMemory)
            {
                case 0:
                    m_sFoundFileList = SmartX.SmartFile.FileSearch("Flash Disk", strSearchWord, chkSubDir.Checked);
                    for (int i = 0; i < m_sFoundFileList.Length; i++)
                    {
                        SmartListBoxAddItem(i);
                    }
                    break;
                case 1:
                    m_sFoundFileList = SmartX.SmartFile.FileSearch("하드 디스크", strSearchWord, chkSubDir.Checked);
                    for (int i = 0; i < m_sFoundFileList.Length; i++)
                    {
                        SmartListBoxAddItem(i);
                    }
                    break;
                case 2:
                    m_sFoundFileList = SmartX.SmartFile.FileSearch("SD Card", strSearchWord, chkSubDir.Checked);
                    for (int i = 0; i < m_sFoundFileList.Length; i++)
                    {
                        SmartListBoxAddItem(i);
                    }
                    break;
                case 3:
                    m_sFoundFileList = SmartX.SmartFile.FileSearch("Flash Disk", strSearchWord, chkSubDir.Checked);
                    for (int i = 0; i < m_sFoundFileList.Length; i++)
                    {
                        SmartListBoxAddItem(i);
                    }
                    m_sFoundFileList = SmartX.SmartFile.FileSearch("하드 디스크", strSearchWord, chkSubDir.Checked);
                    for (int i = 0; i < m_sFoundFileList.Length; i++)
                    {
                        SmartListBoxAddItem(i);
                    }
                    m_sFoundFileList = SmartX.SmartFile.FileSearch("SD Card", strSearchWord, chkSubDir.Checked);
                    for (int i = 0; i < m_sFoundFileList.Length; i++)
                    {
                        SmartListBoxAddItem(i);
                    }
                    break;
                default:
                    break;
            }
        }

        private void SmartListBoxAddItem(int iIndex)
        {
            lstFileList.AddItem(m_sFoundFileList[iIndex].strPath + "\\" + m_sFoundFileList[iIndex].strFileName + "." + m_sFoundFileList[iIndex].strFileExtension);
        }

        private void FileSelect()
        {
            // 선택된 항목이 있는지 확인
            if (lstFileList.SelectItemIndex != -1)
            {
                // 메시지창에 항목 내용 출력
                smartFile1.FilePathName = lstFileList.Items[lstFileList.SelectItemIndex].Trim();
                labFilePath.Text = smartFile1.FilePathName;
            }

            lstFileData.ClearAll();

            if (smartFile1.Open() == true)
            {
                int i = 0;
                smartForm1.Show(2);
                // SmartFile을 사용하여 데이터 읽기.
                smartFile1.StringType.FillBuffer();

                while (smartFile1.StringType.ReadBuffer(i) != null)
                {
                    lstFileData.AddItem(smartFile1.StringType.ReadBuffer(i));
                    i++;
                }
                smartFile1.Close();
            }
            else
            {
                SmartX.SmartMessageBox.Show("File Open Failed");
            }
        }
    }
}