﻿Public Class Form1

    ' FileSearch를 사용해서 저장한 구조체 파일 리스트
    Private m_sFoundFileList As SmartX.SmartFile.SEARCHFILEINFOS()
    Private m_iSelectMemory As Integer

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As EventArgs) Handles MyBase.Load
        ' 현재 Form을 MainForm으로 설정합니다.
        SmartForm1.MainForm = Me
        ' 자식 폼을 추가합니다.
        SmartForm1.AddChildForm(SmartInnerForm1)
        SmartForm1.AddChildForm(SmartInnerForm2)
        SmartForm1.Show(0)

        smartGroupBox1.Visible = False
    End Sub

    Private Sub btnFlashDisk_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnFlashDisk.Click
        m_iSelectMemory = 0
        DeviceSelect(m_iSelectMemory)
    End Sub

    Private Sub btnHardDisk_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnHardDisk.Click
        m_iSelectMemory = 1
        DeviceSelect(m_iSelectMemory)
    End Sub

    Private Sub btnSDCard_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnSDCard.Click
        m_iSelectMemory = 2
        DeviceSelect(m_iSelectMemory)
    End Sub

    Private Sub btnAll_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnAll.Click
        m_iSelectMemory = 3
        DeviceSelect(m_iSelectMemory)
    End Sub

    Private Sub labSearch_Click(ByVal sender As Object, ByVal e As EventArgs) Handles labSearch.Click
        smartGroupBox1.Location = New Point(40, 5)
        smartGroupBox1.Visible = True
        smartKeyboard1.Show()
        smartKeyboard1.TargetInputObject = labSearchWord
    End Sub

    Private Sub btnCompletion_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnCompletion.Click
        labSearch.Text = labSearchWord.Text
        smartGroupBox1.Visible = False
    End Sub

    Private Sub btnSearch_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnSearch.Click
        ' 현재 경로의 파일 리스트를 얻습니다.
        DeviceSelect(m_iSelectMemory)
    End Sub

    Private Sub lstFileList_DoubleClick(ByVal sender As Object, ByVal e As EventArgs) Handles lstFileList.DoubleClick
        FileSelect()
    End Sub

    Private Sub btnScrollButton_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnScrollUp.Click, btnScrollDown.Click
        If sender Is btnScrollUp Then
            lstFileList.ScrollUp()
        Else
            lstFileList.ScrollDown()
        End If
    End Sub

    Private Sub btnBack_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnBack.Click
        lstFileList.ClearAll()
        SmartForm1.Show(0)
    End Sub

    Private Sub btnClose_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnClose.Click
        SmartForm1.Show(1)
    End Sub

    Private Sub btnSelect_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnSelect.Click
        FileSelect()
    End Sub

    Private Sub DeviceSelect(ByVal iSelectMemory As Integer)
        Dim strSearchWord As String

        SmartForm1.Show(1)

        ' 리스트 항목 모두 삭제
        lstFileList.ClearAll()

        If labSearch.Text = "" Then
            strSearchWord = "*.txt;*.dat;"
        Else
            strSearchWord = labSearch.Text
        End If

        Select Case iSelectMemory
            Case 0
                m_sFoundFileList = SmartX.SmartFile.FileSearch("Flash Disk", strSearchWord, chkSubDir.Checked)

                For i As Integer = 0 To m_sFoundFileList.Length - 1
                    SmartListBoxAddItem(i)
                Next

            Case 1
                m_sFoundFileList = SmartX.SmartFile.FileSearch("하드 디스크", strSearchWord, chkSubDir.Checked)

                For i As Integer = 0 To m_sFoundFileList.Length - 1
                    SmartListBoxAddItem(i)
                Next

            Case 2
                m_sFoundFileList = SmartX.SmartFile.FileSearch("SD Card", strSearchWord, chkSubDir.Checked)

                For i As Integer = 0 To m_sFoundFileList.Length - 1
                    SmartListBoxAddItem(i)
                Next

            Case 3
                m_sFoundFileList = SmartX.SmartFile.FileSearch("Flash Disk", strSearchWord, chkSubDir.Checked)

                For i As Integer = 0 To m_sFoundFileList.Length - 1
                    SmartListBoxAddItem(i)
                Next

                m_sFoundFileList = SmartX.SmartFile.FileSearch("하드 디스크", strSearchWord, chkSubDir.Checked)

                For i As Integer = 0 To m_sFoundFileList.Length - 1
                    SmartListBoxAddItem(i)
                Next

                m_sFoundFileList = SmartX.SmartFile.FileSearch("SD Card", strSearchWord, chkSubDir.Checked)

                For i As Integer = 0 To m_sFoundFileList.Length - 1
                    SmartListBoxAddItem(i)
                Next

            Case Else
        End Select
    End Sub

    Private Sub SmartListBoxAddItem(ByVal iIndex As Integer)
        lstFileList.AddItem(m_sFoundFileList(iIndex).strPath & "\" + m_sFoundFileList(iIndex).strFileName & "." + m_sFoundFileList(iIndex).strFileExtension)
    End Sub

    Private Sub FileSelect()
        ' 선택된 항목이 있는지 확인
        If lstFileList.SelectItemIndex <> -1 Then
            ' 메시지창에 항목 내용 출력
            SmartFile1.FilePathName = lstFileList.Items(lstFileList.SelectItemIndex).Trim()
            labFilePath.Text = SmartFile1.FilePathName
        End If

        lstFileData.ClearAll()

        If SmartFile1.Open() = True Then
            Dim i As Integer = 0
            SmartForm1.Show(2)
            ' SmartFile을 사용하여 데이터 읽기.
            SmartFile1.StringType.FillBuffer()

            While SmartFile1.StringType.ReadBuffer(i) IsNot Nothing
                lstFileData.AddItem(SmartFile1.StringType.ReadBuffer(i))
                i += 1
            End While

            SmartFile1.Close()
        Else
            SmartX.SmartMessageBox.Show("File Open Failed")
        End If
    End Sub
End Class
